#include "include/uname.h"
#include "include/types.h"
#include "include/string.h"
#include "include/syscall.h"
#include "include/vm.h"

uint64
sys_uname(void)
{
  uint64 addr;
  if(argaddr(0,&addr)<0)
    return -1;
  struct utsname u;
  safestrcpy(u.sysname, "xv6", sizeof(u.sysname));
  safestrcpy(u.nodename, "localhost", sizeof(u.nodename));
  safestrcpy(u.release, "1.0", sizeof(u.release));
  safestrcpy(u.version, "xv6 version", sizeof(u.version));
  safestrcpy(u.machine, "riscv64", sizeof(u.machine));
  safestrcpy(u.domainname, "localdomain", sizeof(u.domainname));
  if(copyout2(addr,(char*)&u,sizeof(u))<0)
    return -1;
  return 0;
}