#ifndef __TIME_H
#define __TIME_H

#include "types.h"

// 定义 timeval 结构体，表示时间的秒和微秒
struct timeval {
    uint64 tv_sec;  // 自 Unix 纪元以来的秒数
    uint64 tv_usec; // 秒内的微秒数
};

// // 定义 timezone 结构体，表示时区信息
// struct timezone {
//     int tz_minuteswest; // UTC 西边的分钟数
//     int tz_dsttime;     // 夏令时标志
// };

uint64 sys_gettimeofday(void);
long get_uptime(void);

#endif