#ifndef __UNAME_H
#define __UNAME_H

#include "types.h"

struct utsname {
    char sysname[65];    // 操作系统名称
    char nodename[65];   // 主机名称
    char release[65];    // 版本号
    char version[65];    // 版本信息
    char machine[65];    // 架构类型
    char domainname[65]; // 域名信息
};

uint64 sys_uname(void);

#endif